#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

void InitA(int T, int X);
int GameA(int I, int J);

void InitB(int T);
int GameB(int I, int J);

int main(int argc, char **argv) {
  FILE *in, *out;
  int T, X, I, J, result, i, Y, outcome;
  char *call_order;

  if(argc == 1) {
    in = stdin;
    out = stdout;
  } else if(argc == 3) {
    in = fopen(argv[1], "r");
    if(!in) {
      fprintf(stderr,
          "messenger grader: error opening input file %s: %s\n",
          argv[1], strerror(errno));
    }

    out = fopen(argv[2], "w");
    if(!out) {
      fprintf(stderr,
          "messenger grader: error opening output file %s: %s\n",
          argv[2], strerror(errno));
    }
  } else {
    fprintf(stderr, "usage: %s [<input> <output>]\n", argv[0]);
    exit(1);
  }

  result = fscanf(in, "%d", &T);
  if(result < 1) {
    fprintf(stderr, "messenger grader: error reading T\n");
    exit(1);
  }

  result = fscanf(in, "%d", &X);
  if(result < 1) {
    fprintf(stderr, "messenger grader: error reading X\n");
    exit(1);
  }

  result = fscanf(in, "%d", &I);
  if(result < 1) {
    fprintf(stderr, "messenger grader: error reading I\n");
    exit(1);
  }

  result = fscanf(in, "%d", &J);
  if(result < 1) {
    fprintf(stderr, "messenger grader: error reading J\n");
    exit(1);
  }

  call_order = (char*)malloc(sizeof(char)*10001);
  if(!call_order) {
    fprintf(stderr, "messenger grader: error allocating memory: %s\n",
        strerror(errno));
    exit(1);
  }

  result = fscanf(in, " %10000[AB]", call_order);
  if(result < 1) {
    fprintf(stderr, "messenger grader: error reading call_order\n");
    exit(1);
  }

  fclose(in);

  InitA(T, X);
  InitB(T);

  outcome = 6;

  for(i = 0; call_order[i]; ++i) {
    int command;
    if(call_order[i] == 'A') {
      command = GameA(I, J);
    } else {
      command = GameB(I, J);
    }

    if(command == -1) {
      --I;
    } else if(command == -2) {
      ++I;
    } else if(command == -3) {
      --J;
    } else if(command == -4) {
      ++J;
    } else if(command > 0 && call_order[i] != 'A') {
      Y = command;
      if(Y == X) {
        outcome = 0;
      } else {
        outcome = 5;
      }
      goto fin;
    } else {
      if(call_order[i] == 'A') {
        outcome = 1;
      } else {
        outcome = 3;
      }
      goto fin;
    }

    if(I <= 0 || I > 4 || J <= 0 || J > 4) {
      if(call_order[i] == 'A') {
        outcome = 2;
      } else {
        outcome = 4;
      }
      goto fin;
    }
  }
fin:

  free(call_order);

  if(outcome == 0) {
    printf("Accepted\n");
  } else if(outcome == 5) {
    printf("Wrong Answer [%d] : X = %d, Y = %d\n", outcome, X, Y);
  } else {
    printf("Wrong Answer [%d]\n", outcome);
  }

  return outcome;
}
